newscripts = false

do
capzone1 = ZONE_POLYGON:New("AS1",GROUP:FindByName("AS1")) -- over Emerits
capzone2 = ZONE_POLYGON:New("AS2",GROUP:FindByName("AS2")) -- over straight 
capzone3 = ZONE_POLYGON:New("AS3",GROUP:FindByName("AS3")) -- western
capzone4 = ZONE_POLYGON:New("AS4",GROUP:FindByName("AS4")) -- eastern
capzone5 = ZONE_POLYGON:New("AS4",GROUP:FindByName("AS5")) -- mid

fszone1 = ZONE_POLYGON:New("FS1",GROUP:FindByName("AS1"))
fszone2 = ZONE_POLYGON:New("FS2",GROUP:FindByName("AS2"))
end

fgroup = {
ClassName = "Fighter Group",
}

-- Creates our fighter group so we can store it in a table for easier look up
-- types are 1 Cap, 2 Fighter Sweep at the moment.
function fgroup:create(name,isgroup,type,ewradar,minspeed,maxspeed,minaltitude,maxaltitude,engagedistance,airbase,primary,taskingzone)
  local self = BASE:Inherit(self, BASE:New()) -- #SIM_RADIO
  BASE:E({"Creating Fighter Group",name,isgroup,type,ewradar,minspeed,maxspeed,minaltitude,maxaltitude,engagedistance,airbase,primary,taskingzone})
  if isgroup == nil then
    isgroup = false
  end
  if isgroup == false then
    self.group = GROUP:FindByName(name)
    self.name = name
    self.original = self.group:GetName()
  else
    self.group = name
    self.name = self.group:GetName()
    self.original = self.group:GetName()
  end
  self.taskingzone = taskingzone
  self.minspeed = minspeed
  self.maxspeed = maxspeed
  self.maxaltitude = maxaltitude
  self.minaltitude = minaltitude
  self.engagedistance = engagedistance
  self.primary = primary
  self.airbase = AIRBASE:FindByName(airbase)
  self.alive = true
  self.active = false
  self.takeoff = false
  self.regenerating = false
  if type == nil then
    self.type = 1
  else
    self.type = type
  end
  self.ewradar = ewradar
  self.air = false
  BASE:E({"Done Creating Fighter Group"})
  return self
end
function checkheading(h)
  if h < 0 then
    h = h + 360
  elseif h > 360 then
      h = h - 360
  end
  return h
end


function Fence(AIGroup,ROE)
  BASE:E({"Fence",ROE,AIGroup:GetName()})
  if ROE == "free" then
    AIGroup:OptionROEWeaponFree(true)
    AIGroup:OptionROTEvadeFire(true)
    AIGroup:OptionRestrictBurner(false)
  elseif ROE == "return" then
    AIGroup:OptionROEReturnFire()
    AIGroup:OptionRestrictBurner(false)
  else
    AIGroup:OptionROEHoldFire()
  end
  AIGroup:OptionRTBBingoFuel(true)
  AIGroup:OptionRTBAmmo(Weapon.flag.AnyWeapon)

end

function fgroup:Fence(AIGroup,ROE)
  BASE:E({"Fence",ROE,AIGroup:GetName()})
  if ROE == "free" then
    AIGroup:OptionROEWeaponFree(true)
    AIGroup:OptionROTEvadeFire(true)
    AIGroup:OptionRestrictBurner(false)
  elseif ROE == "return" then
    AIGroup:OptionROEReturnFire()
    AIGroup:OptionRestrictBurner(false)
  else
    AIGroup:OptionROEHoldFire()
  end
  AIGroup:OptionRTBBingoFuel(true)
  AIGroup:OptionRTBAmmo(Weapon.flag.AnyWeapon)

end

function fgroup:SetCapTask(TaskingZone,duration)
  BASE:E({self.name,"CAP TASKING"})
  local engagedistance = UTILS.NMToMeters(self.engagedistance)
  local taskingCoord = TaskingZone:GetRandomCoordinate() -- this gets us our random coordinate point
  local startCoord = self.group:GetCoordinate() -- Our starting Zone.
  local distance = startCoord:Get2DDistance(taskingCoord) -- Distance to the coord so we can work wit it.
  local headingto = startCoord:HeadingTo(taskingCoord) -- heading from our current point ot the target coord.
  local capleg = math.random(UTILS.NMToMeters(10,25))
  local capheading = math.random(0,359)
  local lr = math.random(0,1) -- are we going left or right.
  local pathingtype = math.random(0,1)
  local wpsplit = (distance / (math.random(1,8)) )-- were we want to move wp 3 and 5 by
  local d1 = distance - wpsplit -- gives us the actual distance
  local altitude = math.random(self.minaltitude,self.maxaltitude)
  local h1 = 0 -- heading offset 1
  local h2 = 0 -- heading offset 2
  local wp = {}
  local tasks = {}
  local Waypoints = {}
  local duration = (duration * 60)
  BASE:E({self.name,"start making wp's"})
  -- make our first wp
  local coordalt = startCoord:GetLandHeight()
  if (startCoord.y == coordalt) or (startCoord.y < (coordalt + 50)) then
    startCoord.y = startCoord.y + UTILS.FeetToMeters(500) -- add 500 ft to our start coord.
  end
  if pathingtype == 0 then
    if lr == 0 then
      h1 = headingto - math.random(2,7) -- if we are left neg the first 
      h2 = headingto + math.random(2,7) -- plus the second
    else
      h1 = headingto + math.random(2,7) -- if we are right plus the first
      h2 = headingto - math.random(2,7) -- neg the second.
    end
  elseif pathingtype == 1 then
    h1 = headingto - 2
    h2 = headingto + 2
  end
  
 -- now make certain we don't have values over 360 or under 0.
  h1 = checkheading(h1)
  h2 = checkheading(h2)
  
  local t1 = startCoord:Translate(50,math.random(0,359))
  t1.y = t1.y + UTILS.FeetToMeters(2500)
  local c1 = startCoord:Translate(wpsplit,h1) -- create wp 3 co
  local c1distance = startCoord:Get2DDistance(c1)
  local tdistance = startCoord:Get2DDistance(taskingCoord)
  if c1distance > tdistance then
    c1 = startCoord:Translate((tdistance * 0.5),h1) -- create wp 3 co
  end
  c1.y = altitude
  local c2 = startCoord:Translate(wpsplit,h2) -- create wp 5 co.
  local c2distance = startCoord:Get2DDistance(c2)
  if c2distance > tdistance then
    c2 = startCoord:Translate((tdistance * 0.5),h2) -- create wp 3 co
  end
  c2.y = altitude
  taskingCoord.y = altitude
  local oc = taskingCoord:Translate(capleg,capheading)
  BASE:E({"WP1"})
  wp[1] = startCoord:WaypointAirTakeOffRunway("Baro",UTILS.KnotsToKmph(250))
  BASE:E({"WP2"})
  wp[2] = t1:WaypointAirTurningPoint("BARO",UTILS.KnotsToKmph(450),nil,"Take off")
  BASE:E({"WP3"})
  tasks = self.group:EnRouteTaskEngageTargets(UTILS.NMToMeters(self.engagedistance),{"Air","Missile"},1) 
  self.group:SetTaskWaypoint(wp[2],tasks)
  
  wp[3] = c1:WaypointAirTurningPoint("BARO",math.random(self.minspeed,self.maxspeed),nil,"Fence In")
  tasks = self.group:TaskFunction("Fence",self.group,"free")
  self.group:SetTaskWaypoint(wp[3],tasks)
  BASE:E({"WP4"})
  local taskorbit = self.group:TaskOrbit(taskingCoord,altitude,UTILS.KmphToMps(math.random(self.minspeed,self.maxspeed)),oc)
  local taskcond = self.group:TaskCondition(nil,nil,nil,nil,duration,nil)
  local taskcont = self.group:TaskControlled(taskorbit, taskcond)
  wp[4] = taskingCoord:WaypointAirTurningPoint("BARO",math.random(self.minspeed,self.maxspeed),{taskcont},"Cap Hold")
  BASE:E({"WP5"})
  wp[5] = c2:WaypointAirTurningPoint("BARO",math.random(self.minspeed,self.maxspeed),nil,"Fence Out")
  tasks = self.group:TaskFunction("Fence",self.group,"return")
  self.group:SetTaskWaypoint(wp[5],tasks)
  BASE:E({"WP6"})  
  wp[6] = startCoord:WaypointAir("BARO",_type,_action,UTILS.KnotsToKmph(350),true,self.airbase,nil,"home")
  wp[7] = startCoord:WaypointAirLanding(UTILS.KnotsToMps(250),self.airbase,nil,"Landing")
  BASE:E({"Build Route"})
  for i,p in ipairs(wp) do
    table.insert(Waypoints,i,wp[i])
  end
  BASE:E({"Send Route "})
  self.group:Route(Waypoints, 0.5)
  BASE:E({"Done"})
  self.takeoff = true
end



--- Creates a Fighter Sweep Tasking
-- @function [parent=#AI_RTASKING
-- @param Wrapper.Controllable#CONTROLLABLE Controllable The Controllable Object managed by the FSM.
function fgroup:SetFSTask(TaskingZone)
  BASE:E({self.name,"FS TASKING"})
  distance = 1000 
  local taskingCoord = TaskingZone:GetRandomCoordinate() -- this gets us our random coordinate point
  local startCoord startCoord = self.group:GetCoordinate() -- Our starting Zone.
  local whilecounter = 0
  distance = startCoord:Get2DDistance(taskingCoord) -- Distance to the coord so we can work wit it.
  BASE:E({self.name,"Distance",distance})
  while ((UTILS.MetersToNM(distance) > 350)) do   
    BASE:E({self.name,"Distance was > 350",UTILS.MetersToNM(distance),whilecounter})
    taskingCoord = TaskingZone:GetRandomCoordinate() -- this gets us our random coordinate point
    distance = startCoord:Get2DDistance(taskingCoord) -- Distance to the coord so we can work wit it.
    BASE:E({self.name,"Distance now is",UTILS.MetersToNM(distance),whilecounter})
    whilecounter = whilecounter + 1
    if whilecounter > 20 then
      BASE:E({self.name,"WHILE COUNTER IS OVER 10 Breakout of the loop and just useone at maxdistance towards what we have."})
      local heading = startCoord:HeadingTo(taskingCoord)
      taskingCoord = startCoord:Translate(heading,UTILS.NMToMeters(340))
      distance = startCoord:Get2DDistance(taskingCoord)
      BASE:E({self.name,"Distance now is",UTILS.MetersToNM(distance),whilecounter})
      self.takeoff = true
    end
  end
  
  local headingto = startCoord:HeadingTo(taskingCoord) -- heading from our current point ot the target coord.
  local lr = math.random(0,1) -- are we going left or right.
  local wpsplit = (distance / 2) / (math.random(1,4)) -- were we want to move wp 3 and 5 by
  if UTILS.MetersToNM(wpsplit) > 120 then
    BASE:E({self.name,"WP Split 1 was over 120nm clamping"})
    wpsplit = UTILS.NMToMeters(120)
  end
  local d1 = distance - wpsplit -- gives us the actual distance
  wpsplit = wpsplit * (math.random(0.5,0.8))
  local d2 = distance - wpsplit
  local altitude = math.random(self.MinAltitude,self.MaxAltitude)
  if UTILS.MetersToFeet(altitude) < 10000 then
    altitude = UTILS.FeetToMeters(19000)
  end
  BASE:E({self.name,"Altitude for mission will be",altitude})
  local h1 = 0 -- heading offset 1
  local h2 = 0 -- heading offset 2
  local wp = {}
  local tasks = {}
  local Waypoints = {}
  BASE:E({self.name,"start making wp's"})
  -- make our first wp
  local coordalt = startCoord:GetLandHeight()
  if (startCoord.y == coordalt) or (startCoord.y < (coordalt + 50)) then
    startCoord.y = startCoord.y + UTILS.FeetToMeters(500) -- add 500 ft to our start coord.
  end
  if lr == 0 then
   h1 = headingto - math.random(10,25) -- if we are left neg the first 
   h2 = headingto + math.random(10,25) -- plus the second
  else
   h1 = headingto + math.random(10,25) -- if we are right plus the first
   h2 = headingto - math.random(10,25) -- neg the second.
  end
 -- now make certain we don't have values over 360 or under 0.
  h1 = checkheading(h1)
  h2 = checkheading(h2)
  
  local t1 = startCoord:Translate(500,math.random(0,359))
  t1.y = t1.y + UTILS.FeetToMeters(1500)
  local c1 = startCoord:Translate(d1,h1) -- create wp 3 co
  c1.y = altitude
  local c2 = startCoord:Translate(d1,h2) -- create wp 5 co.
  c2.y = altitude
  
  local c1_1 = startCoord:Translate(d2,h1) -- fence in
  c1_1.y = altitude 
  local c2_1 = startCoord:Translate(d2,h2) -- fence out
  c2_1.y = altitude
  
  taskingCoord.y = altitude
  BASE:E({"WP1"})
  wp[1] = startCoord:WaypointAirTakeOffRunway("Baro",UTILS.KnotsToKmph(250))
  BASE:E({"WP2"})
  wp[2] = t1:WaypointAirTurningPoint("BARO",UTILS.KnotsToKmph(350),nil,"Take off")
  BASE:E({"WP3"})
  wp[3] = c1_1:WaypointAirTurningPoint("BARO",UTILS.KnotsToKmph(450),nil,"Fence In")
  self.group:OptionRestrictBurner(true)
  tasks = self.group:EnRouteTaskEngageTargets(UTILS.NMToMeters(self.engagedistance),{"Air","Missile"},1)
  self.group:SetTaskWaypoint(wp[2],tasks)
  tasks = self.group:TaskFunction("Fence",self.group,"free")
  self.group:SetTaskWaypoint(wp[3],tasks)
  BASE:E({"WP4"})
  wp[4] = c1:WaypointAirTurningPoint("BARO",math.random(self.MinSpeed,self.MaxSpeed),nil,"Sweep 1")
  BASE:E({"WP5"})
  wp[5] = taskingCoord:WaypointAirTurningPoint("BARO",math.random(self.MinSpeed,self.MaxSpeed),nil,"Sweep 2")
  BASE:E({"WP6"})
  wp[6] = c2:WaypointAirTurningPoint("BARO",math.random(self.MinSpeed,self.MaxSpeed),nil,"Sweep 3")
  BASE:E({"WP7"})
  wp[7] = c2_1:WaypointAirTurningPoint("BARO",UTILS.KnotsToKmph(450),nil,"Fence Out")
  tasks = self.group:TaskFunction("Fence",self.group,"return")
  self.group:SetTaskWaypoint(wp[7],tasks)
  BASE:E({"WP8"})
  wp[8] = startCoord:WaypointAir("BARO",_type,_action,UTILS.KnotsToKmph(350),true,self.airbase,nil,"home")
  BASE:E({"WP9"})
  wp[9] = startCoord:WaypointAirLanding(UTILS.KnotsToMps(250),self.airbase,nil,"Landing")
  BASE:E({"Task WP"})
  for i,p in ipairs(wp) do
    table.insert(Waypoints,i,wp[i])
  end
  BASE:E({"Route"})
  self.group:Route(Waypoints, 0.5)
  BASE:E({"Done"})
  self.takeoff = true
end


function fgroup:spawn()
      BASE:E({"Starting Spawner for", self.name,self.original})
    if self.group:IsAlive() == true then
        self.group:Destroy()
    end
    self.group = SPAWN:New(self.original):InitRandomizeRoute(2,6,20000,1000):OnSpawnGroup(function(spawngroup)
      self.name = spawngroup:GetName() 
      self.active = false
      self.alive = true
      self.takeoff = false
      self.air = false
      BASE:E({self.name,spawn})
    end,{}):InitRepeatOnEngineShutDown():InitCleanUp(300):Spawn()
    self.starthandlers(self)
 end
 function fgroup:destroy()
  if self.group:IsAlive() ~= nil then
    self.group:Destroy()
    self.active = false
    self.alive = false
    self.takeoff = false
    self.air = false
    self.regenerating = false
  end
 end
 function fgroup:getactive()
  return self.active
 end
 function fgroup:setactive(v)
  self.active = v
 end
 function fgroup:getalive()
  return self.alive
 end
 function fgroup:gettakeoff()
  return self.takeoff
 end
 
 function fgroup:settakeoff(v)
  self.takeoff = v
 end
 function fgroup:getair()
  return self.air
 end
 function fgroup:setregen(g)
  self.regenerating = g
  return self.regenerating
 end 
 function fgroup:getradar()
  return self.ewradar
 end
 function fgroup:getregen()
  return self.regenerating
 end
 
 function fgroup:getname()
  return self.original
 end
 function fgroup:scramble()
  BASE:E({"Sending Scramble Command for ", self.name})
  trigger.action.pushAITask(self.group:GetDCSObject(), 1)
  self.setactive(self,true)
  self.settakeoff(self,true)
 end
 function fgroup:starthandlers()
  BASE:E({self.name,"Starting Handlers"})
  self.group:HandleEvent(EVENTS.Takeoff,function(EventData) 
    BASE:E({"Group:" .. self.name .. "Has just taken off"})
    self.air = true
    end,self)
  self.group:HandleEvent(EVENTS.Crash,function(EventData)
     BASE:E({"Group:" .. self.name .. "Has just Crashed?"}) 
     -- lets see if both units are dead or just one.
       
       local gunits = self.group:GetUnits()
       local unitcount = #gunits
       local unitalive = 0
        for i = 1, #gunits do
          local gunit = self.group:GetUnit(i)
          if gunit:IsAlive() ~= nil then
            unitalive = unitalive + 1  
          end
        end
       if unitalive == 0 then
        self:setregen(true)
        self.alive(false)
        BASE:E({"All units reported dead, setting to regenerate"})
       end
  end,self)
  self.group:HandleEvent(EVENTS.Land,function(EventData) 
    BASE:E({self.name,"has landed"}) 
    self.air = false
    end,self)
  self.group:HandleEvent(EVENTS.EngineShutdown,function(EventData) 
    BASE:E({self.name,"Has Engine ShutDown"})
    if self.air == true then
      BASE:E({self.name,"Was in the Air we aren't doing nothing crash will handle it"})
    else
      BASE:E({self.name,"Was on the ground, Deleteing and respawning"})
      self.takeoff = false
      self.group:Destroy() 
      self.group = self.spawn(self)
    end
  end,self)
 
 end
 function fgroup:start(type)
  BASE:E({"Sending Start Command for ", self.name})
  if self.group == nil then
    self.group = GROUP:FindByName(self.name)
  end
  trigger.action.pushAITask(self.group:GetDCSObject(), 1)
  self.starthandlers(self)
  self.setactive(self,true)
  
    BASE:E({self.name,"Pushing tasks."})
    if type == "cap" then
      SCHEDULER:New(nil,function() 
      BASE:E({self.name,"Should be starting cap tasking"})
      self.SetCapTask(self,self.taskingzone,60)end,{},15)
    elseif type == "fs" then
      SCHEDULER:New(nil,function() 
        BASE:E({self.name,"Should be starting FS tasking"})
      self.SetFSTask(self,self.taskingzone) 
      end,{},15)
    end
 end
 

 
 
fsqn = {
ClassName = "Fighter Squadron",
}
 
 
function fsqn:New(name,activecap,randomfs,captime,fstime)
  local self = BASE:Inherit(self, BASE:New()) -- #SIM_RADIO
  self.CAPGROUPS = {}
  self.FSGROUPS = {}
  self.name = name
  if activecap ~= nil then
    self.activecap = activecap
  else
    self.activecap = 0
  end
  if randomfs ~= nil then
    self.randomfs = randomfs
  else
    self.randomfs = false
  end 
  if captime ~= nil then
    self.captime = captime
  else
    self.captime = 60
  end
  if fstime ~= nil then
    self.fstime = fstime
  else
    self.fstime = 60
  end
  self.capstarted = 0
  self.fsstarted = 0
  self.capscramble = false
  self.regentimer = nil
  self.maintimer = nil
  self.radartimer = nil
  return self
end
 function fsqn:getcapscramble()
  return self.capscramble
 end
 function fsqn:setcapscramble(v)
  self.capscramble = v
 end
 function fsqn:regenerate(sqn) 
  for i,k in pairs(sqn) do
    if k:getregen() == true then
      BASE:E({k:getname(),k:getregen()})
      k:spawn()
    else
      BASE:E({k:getname(),k:getregen()})
    end 
  end
 end
 
 function fsqn:AddCAPGroup(fgrp)
  BASE:E({"CAPGROUP ADD",fgrp})
  table.insert(self.CAPGROUPS,fgrp)
  BASE:E({table.maxn(self.CAPGROUPS)})
 end
 
 function fsqn:AddFSGroup(fgrp)
  BASE:E({"FSGROUP add",fgrp})
  table.insert(self.FSGROUPS,fgrp)
  BASE:E({table.maxn(self.FSGROUPS)})
 end
 
 function fsqn:SpawnGroups()
  local temp = self.CAPGROUPS
  if #temp ~= 0 then
    for i,k in pairs(self.CAPGROUPS) do
      k:spawn()
    end
  end 
  local temp = self.FSGROUPS
  if #temp ~= 0 then
    for i,k in pairs(self.FSGROUPS) do
      k:spawn()
    end
  end
 end
 
 function fsqn:checkradar(mt)
  local fscount = #mt
  local scrambled = 0 
  if fscount ~= nil then
    if fscount > 0 then
      BASE:E({"We have",fscount,"Fighters ready to sweep"})
      for i,k in pairs(mt) do
        if k:getalive() == true and k:getactive() == false then
          local ew = k:getradar()
          local ewcontacts = ew:getDetectedTargets()
          BASE:E({"Detected Targets within the EW Radar set for:",self.name,#ewcontacts})
          if #ewcontacts ~= 0 then
              k:scramble()
              scrambled = scrambled + 1
          end
        end  
      end
    end
  end
  BASE:E({"Scrambled a ac amount is",scrambled})
 end
 
 function fsqn:Start() 
  BASE:E({self.name,"Starting Fighter Squadron Manager"})
  BASE:E({self.name,"Spawning in Groups"})
  self.SpawnGroups(self)
  BASE:E({self.name,"Setting up Regneration timer"})
  self.regentimer = SCHEDULER:New(nil,function() 
    BASE:E({self.name,"Checking Squadrons for Regeneration"})
      temp = self.CAPGROUPS
      if #temp ~= 0 then 
        for i,k in pairs(self.CAPGROUPS) do
          if k:getregen() == true then
            BASE:E({k:getname(),k:getregen()})
            k:spawn()      
          end
        end
      end
      temp = self.FSGROUPS
      if #temp ~= 0 then
        for i,k in pairs(self.FSGROUPS) do
          if k:getregn() == true then
            BASE:E({k:getname(),k:getregen()})
            k:spawn()
          end
        end
      end
  end,{},1800,1800)
  
  BASE:E({self.name,"Starting Caps",self.activecap})
  if self.activecap ~= 0 then
    for i,k in pairs(self.CAPGROUPS) do 
      if self.capstarted < self.activecap then
        if k:getalive() == true and k:getactive() == false and k:gettakeoff() == false then 
          k:start("cap")
          self.capstarted = self.capstarted + 1
        end
      end
    end
  end
  if self.randomfs == true then
    for i,k in pairs(self.FSGROUPS) do 
      local temp = math.random(1,2)
      if temp == 1 then
          if k:getalive() == true and k:getactive() == false and k:gettakeoff() == false then
            k:start("fs")
            self.fsstarted = self.fsstarted + 1
          end
      end
    end
  end
  BASE:E({self.name,"Starting Main timer"})
   self.maintimer = SCHEDULER:New(nil,function() 
    -- we run a check we want to check our active units.
    local stillactive = 0
    for i,k in pairs(self.CAPGROUPS) do
      if k:getactive() == true and k:gettakeoff() == true then
        stillactive = stillactive + 1
        if k:getregen() == true then
          stillactive = stillactive - 1
          k:setactive(false)
        end
      end
    end
    self.capstarted = stillactive
    if self.capstarted < self.activecap then
      for i,k in pairs(self.CAPGROUPS) do 
        if k:getactive() == false then       
          if k:getregen() == false then
            k:start()
            self.capstarted = self.capstarted + 1
          end
        end
      end
    end
  end,{},300,300)
  BASE:E({self.name,"Radar Check Timer"})
  self.radartimer = SCHEDULER:New(nil,function() 
    fsqn.checkradar(self,self.FSGROUPS)
    if self.capscramble == true then
      fsqn.checkradar(self,self.CAPGROUPS)
    end
  end,{},300,120)
 end

  function fsqn:Stop()
    BASE:E({self.name,"Stopping all timers, and deleting all units"})
    self.radartimer:Stop()
    self.maintimer:Stop()
    self.regentimer:Stop()
    for i,k in pairs(self.CAPGROUPS) do 
      k:destroy()
    end
    for i,k in pairs(self.FSGROUPS) do 
      k:destroy()
    end
  end
 
 if newscripts == true then
 
 shiraz = fsqn:New("Shiraz CAP Sqn Group 1",4,true,60,120)
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 1",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone3))
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 2",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone5))
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 3",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone3))
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 4",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone5))
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 5",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone3))
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 6",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone5))
 shiraz:AddCAPGroup(fgroup:create("Shiraz CAP Sqn Group 7",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"CAP",capzone3))
 
 shiraz:AddFSGroup(fgroup:create("Shiraz FS Sqn Group 1",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"FS",fszone1))
 shiraz:AddFSGroup(fgroup:create("Shiraz FS Sqn Group 2",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"FS",fszone2))
 shiraz:AddFSGroup(fgroup:create("Shiraz FS Sqn Group 3",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Shiraz_International_Airport,"FS",fszone1))
 
 shiraz:Start()
 
 kerman = fsqn:New("Kerman Squadron",4,true,60,120)
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 1",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone2))
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 2",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone4))
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 3",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone5))
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 4",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone2))
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 5",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone4))
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 6",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone5))
 kerman:AddCAPGroup(fgroup:create("Kerman CAP Group 7",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW North"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"CAP",capzone4))
 
 kerman:AddFSGroup(fgroup:create("Kerman FS Group 1",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"FS",fszone1))
 kerman:AddFSGroup(fgroup:create("Kerman FS Group 2",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"FS",fszone2))
 kerman:AddFSGroup(fgroup:create("Kerman FS Group 4",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"FS",capzone5))
 kerman:AddFSGroup(fgroup:create("Kerman FS Group 5",false,1,IranIADS:getEarlyWarningRadarByUnitName("REW West Shiraz"),375,700,17000,45000,60,AIRBASE.PersianGulf.Kerman_Airport,"FS",capzone4))
 kerman:Start()
 
 else
  BASE:E({"New Scripts was false using A2ADispatcher"})
  RAS = ZONE_POLYGON:New("RAS",GROUP:FindByName("RAS"))
  rlooksee = SET_GROUP:New():FilterPrefixes({"REW","RSAM","Overlord"}):FilterCoalitions("red"):FilterActive():FilterStart()
  rdet = DETECTION_AREAS:New(rlooksee,45000)
  ra2disp = AI_A2A_DISPATCHER:New(rdet)
  ra2disp:SetBorderZone(RAS)
  ra2disp:SetDefaultFuelThreshold(0.4)
  ra2disp:SetDefaultGrouping(2)
  ra2disp:SetDefaultOverhead(1.0)
  ra2disp:SetSquadron("Shiraz",AIRBASE.PersianGulf.Shiraz_International_Airport,{"F4_Template","SU33_TEMPLATE"},12)
  ra2disp:SetSquadron("Shiraz2",AIRBASE.PersianGulf.Shiraz_International_Airport,{"F5_Template","MIG29_Template"},12)
  ra2disp:SetSquadron("Shiraz INT",AIRBASE.PersianGulf.Shiraz_International_Airport,{"F5_Template","MIG29_Template"},8)
  ra2disp:SetSquadron("Kerman",AIRBASE.PersianGulf.Kerman_Airport,{"F14_Template","JF17_Template","M2000_Template"},12)
  ra2disp:SetSquadron("Kerman2",AIRBASE.PersianGulf.Kerman_Airport,{"F14_Template","M2000_Template"},12)
  ra2disp:SetSquadron("Kerman INT",AIRBASE.PersianGulf.Kerman_Airport,{"MIG21_Template"},8)
  ra2disp:SetSquadron("Bandar Abbas",AIRBASE.PersianGulf.Bandar_Abbas_Intl,{"MIG21_Template"},8)
  ra2disp:SetSquadron("Bandar Abbas INT",AIRBASE.PersianGulf.Bandar_Abbas_Intl,{"MIG21_Template"},4)
  ra2disp:SetSquadron("Kish",AIRBASE.PersianGulf.Kish_International_Airport,{"M2000_Template"},8)
  ra2disp:SetSquadron("Lar",AIRBASE.PersianGulf.Lar_Airbase,{"F4_Template"},4)
  ra2disp:SetEngageRadius(UTILS.NMToMeters(80))
  ra2disp:SetDisengageRadius(UTILS.NMToMeters(200))
  ra2disp:SetGciRadius(UTILS.NMToMeters(120))
  ra2disp:SetDefaultTakeoffFromParkingHot()
  ra2disp:SetDefaultLandingAtEngineShutdown()
  ra2disp:SetSquadronCap("Shiraz",capzone3,UTILS.FeetToMeters(15000),UTILS.FeetToMeters(40000),UTILS.KnotsToKmph(350),UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(500),UTILS.KnotsToKmph(750),"BARO")
  ra2disp:SetSquadronCapInterval("Shiraz",2,(60*5),(60*45),1.0)
  ra2disp:SetSquadronCap("Shiraz2",capzone5,UTILS.FeetToMeters(15000),UTILS.FeetToMeters(40000),UTILS.KnotsToKmph(350),UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(500),UTILS.KnotsToKmph(750),"BARO")
  ra2disp:SetSquadronCapInterval("Shiraz2",2,(60*5),(60*45),1.0)
  ra2disp:SetSquadronGci("Shiraz INT",UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(800))
  ra2disp:SetSquadronCap("Kerman",capzone4,UTILS.FeetToMeters(15000),UTILS.FeetToMeters(40000),UTILS.KnotsToKmph(350),UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(500),UTILS.KnotsToKmph(750),"BARO")
  ra2disp:SetSquadronCapInterval("Kerman",2,(60*5),(60*45),1.0)
  ra2disp:SetSquadronCap("Kerman2",capzone2,UTILS.FeetToMeters(15000),UTILS.FeetToMeters(40000),UTILS.KnotsToKmph(350),UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(500),UTILS.KnotsToKmph(750),"BARO")
  ra2disp:SetSquadronCapInterval("Kerman2",2,(60*5),(60*45),1.0)
  ra2disp:SetSquadronGci("Kerman INT",UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(800))
  ra2disp:SetSquadronCap("Bandar Abbas",capzone2,UTILS.FeetToMeters(15000),UTILS.FeetToMeters(40000),UTILS.KnotsToKmph(350),UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(500),UTILS.KnotsToKmph(750),"BARO")
  ra2disp:SetSquadronCapInterval("Bandar Abbas",2,(60*5),(60*45),1.0)
  ra2disp:SetSquadronGci("Bandar Abbas INT",UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(800))
  ra2disp:SetSquadronGci("Lar",UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(800))
  ra2disp:SetSquadronCap("Kish",capzone4,UTILS.FeetToMeters(15000),UTILS.FeetToMeters(40000),UTILS.KnotsToKmph(350),UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(500),UTILS.KnotsToKmph(750),"BARO")
  ra2disp:SetSquadronCapInterval("Kish",2,(60*5),(60*45),1.0)
  ra2disp:SetSquadronGci("Kish",UTILS.KnotsToKmph(550),UTILS.KnotsToKmph(800))
  ra2disp:__Start(30)
  
  SCHEDULER:New(nil,function() 
    local tx11 = GROUP:FindByName("Texaco11")
    local tx21 = GROUP:FindByName("Texaco21")
    if tx11:IsAlive() == true then
      if tx11:IsAirborne() == true then
        ra2disp:SetDefaultTanker("Texaco11")
      end
    elseif tx21:IsAlive() == true then
      if tx21:IsAirborne() == true then
        ra2disp:SetDefaultTanker("Texaco21")
      end
    end
  end,{},5,600)
 end