minutes = 60
hours = 6 -- DO NOT SET THIS TO 0, if your not using HOURS level it as 1.
RED_EW_SET = SET_GROUP:New():FilterCoalitions("red"):FilterPrefixes("REW"):FilterStart()
RED_SAM_SET = SET_GROUP:New():FilterCoalitions("red"):FilterActive():FilterPrefixes("RSAM"):FilterStart()
RED_SCUD_SET = SET_GROUP:New():FilterCoalitions("red"):FilterActive():FilterPrefixes("SCUD"):FilterStart()
RED_I_SET = SET_STATIC:New():FilterCoalitions("red"):FilterPrefixes("Iran"):FilterStart()
RED_A_SET = SET_STATIC:New():FilterCoalitions("red"):FilterPrefixes("Army"):FilterStart()

ARMY_INTEL = {}
EW_INTEL = {}
SAM_INTEL = {}
SCUD_INTEL = {}
INF_INTEL = {}
EW_INTELOUT = 0
SAM_INTELOUT = 0
SCUD_INTELOUT = 0
INF_INTELOUT = 0
intel_reports = {}
-- set up our data 

RED_EW_SET:ForEachGroupAlive(function(g) 
  BASE:E({g})
  local gid =g:GetName()
  local data = {group = nil, displayed = false,text="",markerid = nil}
  EW_INTEL[gid] = data
  EW_INTEL[gid].group = g
  EW_INTEL[gid].displayed = true
  local co = g:GetCoordinate()
  local lldm = co:ToStringLLDDM()
  local llds = co:ToStringLLDMS()
  local mgrs = co:ToStringMGRS()
  local text = "CIA Report: Early Warning Radar Detected \n " .. lldm .. "\n " .. llds .. "\n " .. mgrs .. ""
  EW_INTEL[gid].text = text
  intel_reports[gid] = text
  MESSAGE:New(text,30,"CIA Intel Update"):ToAll()  
  local m = co:MarkToAll(EW_INTEL[gid].text,true)
  EW_INTEL[gid].markerid = m
end)

RED_SAM_SET:ForEachGroupAlive(function(g) 
  local gid =g:GetName()
  local data = {group = g, displayed = false,text="",markerid = nil}
  SAM_INTEL[gid] = data
  intel_reports[gid] = ""
end)

RED_SCUD_SET:ForEachGroupAlive(function(g) 
  local gid =g:GetName()
  local data = {group = g, displayed = false,text="",markerid = nil}
  SCUD_INTEL[gid] = data
  intel_reports[gid] = ""
end)
RED_I_SET:ForEachStatic(function(g) 
  local gid =g:GetName()
  local data = {static = g, displayed = false,text="",markerid = nil}
  INF_INTEL[gid] = data
  intel_reports[gid] = ""
end)

RED_A_SET:ForEachStatic(function(g) 
  local gid =g:GetName()
  local data = {static = g, displayed = false,text="",markerid = nil}
  ARMY_INTEL[gid] = data
  intel_reports[gid] = ""
end)

SCHEDULER:New(nil,function() 
BASE:E({"Intelligence Update in progress"})
BASE:E({"Checking all Markers and updating markers"})

for i,k in pairs(EW_INTEL) do 
  if k.group:IsAlive() ~= true and k.displayed == true then
    COORDINATE:RemoveMark(k.markerid)
    intel_reports[k.group:GetName()] = ""
  end
end

for i,k in pairs(SAM_INTEL) do 
  if k.group:IsAlive() ~= true and k.displayed == true then
    COORDINATE:RemoveMark(k.markerid)
    intel_reports[k.group:GetName()] = ""
  end
end

for i,k in pairs(SCUD_INTEL) do 
  if k.group:IsAlive() ~= true and k.displayed == true then
    COORDINATE:RemoveMark(k.markerid)
    intel_reports[k.group:GetName()] = ""
  end
end

for i,k in pairs(INF_INTEL) do 
  if k.static:IsAlive() ~= true and k.displayed == true then
    COORDINATE:RemoveMark(k.markerid)
    intel_reports[k.static:GetName()] = ""
  end
end

for i,k in pairs(ARMY_INTEL) do 
  if k.static:IsAlive() ~= true and k.displayed == true then
    COORDINATE:RemoveMark(k.markerid)
    intel_reports[k.static:GetName()] = ""
  end
end
BASE:E({"Dead units should no longer have markers"})

local inteltype = math.random(1,6)
  BASE:E({"Intelligence Reports Type is",inteltype})
if inteltype == 1 or inteltype == 4 or inteltype == 5 then
  BASE:E({"Entered Update SAM INTEL"})
  local intelcount =  math.random(1,4)
  for i = 1,intelcount,1 do
    local updated = false 
    for i,k in pairs(SAM_INTEL) do 
      if updated == false then
        if k.group:IsAlive() == true and k.displayed == false then
          k.displayed = true
          local co = k.group:GetCoordinate()
          local lldm = co:ToStringLLDDM()
          local llds = co:ToStringLLDMS()
          local mgrs = co:ToStringMGRS()
          BASE:E({"Get Group Type:",k.group:GetTypeName()})
          local threatlevel = k.group:GetThreatLevel()
          local text = "CIA Report: Detected Surface to Air Installation \n " .. lldm .. "\n " .. llds .. "\n " .. mgrs .. ""
          k.text = text
          intel_reports[k.group:GetName()] = text
          MESSAGE:New(text,20,"CIA Intel Update"):ToAll()
          local m = co:MarkToAll(k.text,true)
          k.markerid = m
          updated = true
        end
      end
    end
  end
end

if inteltype == 2 or inteltype == 4 or inteltype == 6 then
  BASE:E({"Entered Update SCUD INTEL"})
    local updated = false 
    for i,k in pairs(SCUD_INTEL) do 
      if updated == false then
        if k.group:IsAlive() == true and k.displayed == false then
          BASE:E({"Adding new Intel"})
          k.displayed = true
          local co = k.group:GetCoordinate()
          local lldm = co:ToStringLLDDM()
          local llds = co:ToStringLLDMS()
          local mgrs = co:ToStringMGRS()
          local text = "CIA Report: Detected Possible SCUD, ARTY or ARMY Staging Site. \n " .. lldm .. "\n " .. llds .. "\n " .. mgrs .. ""
          k.text = text
          intel_reports[k.group:GetName()] = text
          MESSAGE:New(text,20,"CIA Intel Update"):ToAll()
          local m = co:MarkToAll(k.text,true)
          k.markerid = m
          updated = true
        end
      end
  end
end

if inteltype == 3 or inteltype == 5 or inteltype == 6 then
  BASE:E({"Entered Update INF INTEL"})
  local intelcount =  math.random(1,2)
  for i = 1,intelcount,1 do
    local updated = false 
    for i,k in pairs(INF_INTEL) do 
      if updated == false then
        if k.static:IsAlive() == true and k.displayed == false then
          BASE:E({"Adding new Intel"})
          k.displayed = true
          local co = k.static:GetCoordinate()
          local lldm = co:ToStringLLDDM()
          local llds = co:ToStringLLDMS()
          local mgrs = co:ToStringMGRS()
          local text = "CIA Report: Detected IADS Critical System. \n " .. lldm .. "\n " .. llds .. "\n " .. mgrs .. ""
          k.text = text
          intel_reports[k.static:GetName()] = text
          MESSAGE:New(text,20,"CIA Intel Update"):ToAll()
          local m = co:MarkToAll(k.text,true)
          k.markerid = m
          updated = true
        end
      end
    end
  end
end
end,{},30,((60*minutes) * hours))